package com.example.appbundletest;

import javax.swing.*;
import java.lang.management.ManagementFactory;
import java.lang.management.RuntimeMXBean;
import java.util.prefs.BackingStoreException;
import java.util.prefs.Preferences;

public class ShowJvmOptions {
    private static final String appIdentifier = "/com/example/Showjvmoptions/JVMOptions";

    public static void main(String[] args) throws BackingStoreException {
        Preferences jvmOptions = Preferences.userRoot().node(appIdentifier);
        String oldVal = jvmOptions.get("MaxMemoryMb", null);
        String maxMemAtStart = (Runtime.getRuntime().maxMemory() / 1024 / 1024) + " MiB";
        RuntimeMXBean runtimeMXBean = ManagementFactory.getRuntimeMXBean();
        String passedMemOption =  runtimeMXBean.getInputArguments().stream().filter(e -> e.startsWith("-Xmx")).findAny().orElse(null);
        String oldValMB = "";
        if ((oldVal != null) && oldVal.startsWith("-Xmx")) {
            oldValMB = oldVal.substring(4, oldVal.length() - 1);
        }
        String message = "JVM launched with memory option "+passedMemOption +
                "\nActual JVM max memory set to " +  maxMemAtStart +
                "\nuserRoot preference read as " + oldVal +
                "\nEnter a new value (just the integer, will be in MB) to save in preferences\n";
        String newValMb = JOptionPane.showInputDialog(null, message, oldValMB);
        if ((newValMb != null) && !newValMb.isEmpty()) {
            jvmOptions.put("MaxMemoryMb", "-Xmx"+newValMb+"M");
            jvmOptions.flush();

        }
    }
}
